/[gentoo-x86]/eclass/elisp.eclass
Gentoo

Contents of /eclass/elisp.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.38 - (hide annotations) (download)
Thu Mar 12 12:08:47 2009 UTC (5 years, 9 months ago) by ulm
Branch: MAIN
Changes since 1.37: +21 -18 lines
Partial sync from Emacs overlay, only documentation and einfo output changes.

1 ulm 1.38 # Copyright 1999-2009 Gentoo Foundation
2 mkennedy 1.1 # Distributed under the terms of the GNU General Public License v2
3 ulm 1.38 # $Header: /var/cvsroot/gentoo-x86/eclass/elisp.eclass,v 1.37 2009/02/07 11:32:45 fauli Exp $
4 vapier 1.4 #
5 ulm 1.20 # Copyright 2002-2003 Matthew Kennedy <mkennedy@gentoo.org>
6 ulm 1.29 # Copyright 2003 Jeremy Maitin-Shepard <jbms@attbi.com>
7 ulm 1.38 # Copyright 2007-2009 Christian Faulhammer <fauli@gentoo.org>
8     # Copyright 2007-2009 Ulrich Müller <ulm@gentoo.org>
9 vapier 1.4 #
10 ulm 1.21 # @ECLASS: elisp.eclass
11     # @MAINTAINER:
12 ulm 1.24 # Feel free to contact the Emacs team through <emacs@gentoo.org> if you
13     # have problems, suggestions or questions.
14 ulm 1.21 # @BLURB: Eclass for Emacs Lisp packages
15     # @DESCRIPTION:
16     #
17 ulm 1.38 # This eclass is designed to install elisp files of Emacs related
18     # packages into the site-lisp directory. The majority of elisp packages
19     # will only need to define the standard ebuild variables (like SRC_URI)
20     # and optionally SITEFILE for successful installation.
21 opfer 1.17 #
22 opfer 1.18 # Emacs support for other than pure elisp packages is handled by
23 ulm 1.20 # elisp-common.eclass where you won't have a dependency on Emacs itself.
24     # All elisp-* functions are documented there.
25 ulm 1.30 #
26     # If the package's source is a single (in whatever way) compressed elisp
27     # file with the file name ${P}.el, then this eclass will move ${P}.el to
28     # ${PN}.el in src_unpack().
29 ulm 1.23
30 ulm 1.38 # @ECLASS-VARIABLE: NEED_EMACS
31 ulm 1.35 # @DESCRIPTION:
32 ulm 1.38 # If you need anything different from Emacs 21, use the NEED_EMACS
33     # variable before inheriting elisp.eclass. Set it to the major version
34     # your package uses and the dependency will be adjusted.
35 ulm 1.35
36 ulm 1.23 # @ECLASS-VARIABLE: DOCS
37     # @DESCRIPTION:
38 opfer 1.19 # DOCS="blah.txt ChangeLog" is automatically used to install the given
39     # files by dodoc in src_install().
40 ulm 1.23
41 ulm 1.38 # @ECLASS-VARIABLE: SITEFILE
42 ulm 1.23 # @DESCRIPTION:
43 ulm 1.38 # Name of package's site-init file. The filename must match the shell
44     # pattern "[1-8][0-9]*-gentoo.el"; numbers below 10 and above 89 are
45     # reserved for internal use. "50${PN}-gentoo.el" is a reasonable choice
46     # in most cases.
47 opfer 1.19
48     inherit elisp-common versionator
49    
50 ulm 1.38 EXPORT_FUNCTIONS \
51     src_unpack src_compile src_install \
52     pkg_setup pkg_postinst pkg_postrm
53    
54 ulm 1.33 DEPEND=">=virtual/emacs-${NEED_EMACS:-21}"
55     RDEPEND=">=virtual/emacs-${NEED_EMACS:-21}"
56 opfer 1.19 IUSE=""
57 opfer 1.18
58 opfer 1.19 elisp_pkg_setup() {
59 ulm 1.33 local need_emacs=${NEED_EMACS:-21}
60     local have_emacs=$(elisp-emacs-version)
61     if ! version_is_at_least "${need_emacs}" "${have_emacs}"; then
62     eerror "This package needs at least Emacs ${need_emacs}."
63 opfer 1.19 eerror "Use \"eselect emacs\" to select the active version."
64 ulm 1.33 die "Emacs version ${have_emacs} is too low."
65 opfer 1.19 fi
66 ulm 1.36 einfo "Emacs version: ${have_emacs}"
67 opfer 1.19 }
68 mkennedy 1.1
69 opfer 1.18 elisp_src_unpack() {
70 ulm 1.33 [ -n "${A}" ] && unpack ${A}
71 ulm 1.30 if [ -f ${P}.el ]; then
72 fauli 1.37 mv ${P}.el ${PN}.el || die
73 opfer 1.18 fi
74 mkennedy 1.5 }
75    
76 opfer 1.18 elisp_src_compile() {
77 ulm 1.35 elisp-compile *.el || die
78 mkennedy 1.5 }
79    
80 opfer 1.18 elisp_src_install() {
81 ulm 1.35 elisp-install ${PN} *.el *.elc || die
82     if [ -n "${SITEFILE}" ]; then
83     elisp-site-file-install "${FILESDIR}/${SITEFILE}" || die
84     fi
85 opfer 1.19 if [ -n "${DOCS}" ]; then
86 fauli 1.37 dodoc ${DOCS} || die
87 opfer 1.19 fi
88 mkennedy 1.5 }
89    
90 opfer 1.18 elisp_pkg_postinst() {
91     elisp-site-regen
92 mkennedy 1.5 }
93    
94 opfer 1.18 elisp_pkg_postrm() {
95     elisp-site-regen
96 mkennedy 1.5 }

  ViewVC Help
Powered by ViewVC 1.1.20